import { system, world } from '@minecraft/server';

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('besmc_change_grabpack_rb:trigger', {
  onUse: e => { e.source.runCommand("function grapack_red_blu_giv"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_clear_grabpack:trigger', {
  onUse: e => { e.source.runCommand("function grapack_clears"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_change_grabpack_gb:trigger', {
  onUse: e => { e.source.runCommand("function grapack_gren_blu_giv"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_limon:trigger', {
  onUse: e => { e.source.runCommand("function Limon"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_change_grabpack_pb:trigger', {
  onUse: e => { e.source.runCommand("function grapack_purple_blu_giv"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_kill_sign:trigger', {
  onUse: e => { durabilityOnChanged(e.itemStack, e.source, false);
e.source.runCommand("function killS"); },
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); e.attackingEntity.runCommand("function killSs"); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_close_door:trigger', {
  onUse: e => { e.source.runCommand("function closedoor"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_change_grabpack_ob:trigger', {
  onUse: e => { e.source.runCommand("function grapack_orange_blu_giv"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_change_grabpack_omb:trigger', {
  onUse: e => { e.source.runCommand("function grapack_omni_blu_giv"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_blue_p:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_blue:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_red_and_blue:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_purple_and_blue:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_omni:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_red:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_omni_and_blue:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_purple:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_blue_om:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_gren:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_blue_o:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_blue_g:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_blue_r:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_gren_active:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_gren_and_blue:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});

initEvent.itemComponentRegistry.registerCustomComponent('besmc_grabpack_orange:trigger', {
  onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
});
 });
